Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports Outlook = Microsoft.Office.Interop.Outlook

'Add-in Express Add-in Module
<GuidAttribute("460CC007-7FFA-4B3D-BA2E-C1986C657CD8"), ProgIdAttribute("OutlookItemEvents.AddinModule"), RunInstaller(True)> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Private WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        '
        'AddinModule
        '
        Me.AddinName = "Outlook Item Events Sample"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub
 
#End Region
 
#Region " ADX automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Add any initialization after the InitializeComponent() call
 
    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return HostApplication
        End Get
    End Property

    Dim itemEvents As OutlookItemEventsClass1
    Dim canConnect As Boolean

    Private Sub AddinModule_AddinStartupComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AddinStartupComplete
        If Me.HostVersion.IndexOf("9.") = 0 Then
            MsgBox("We don't recommend using the 'ADXOutlookItemEvents' class in Microsoft Outlook 2000.\n\rOutlook 2000 can hang in the background.", MsgBoxStyle.OKOnly, Me.AddinName)
        End If
        itemEvents = New OutlookItemEventsClass1(Me)
        canConnect = True
    End Sub

    Private Sub AddinModule_AddinBeginShutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.AddinBeginShutdown
        If Not itemEvents Is Nothing Then itemEvents.Dispose()
    End Sub

    Private Sub adxOutlookEvents_InspectorActivate(ByVal sender As System.Object, ByVal inspector As System.Object, ByVal folderName As String) Handles adxOutlookEvents.InspectorActivate
        If canConnect Then
            itemEvents.ConnectTo(inspector.CurrentItem, True)
        End If
    End Sub

    Private Sub adxOutlookEvents_InspectorClose(ByVal sender As System.Object, ByVal inspector As System.Object, ByVal folderName As String) Handles adxOutlookEvents.InspectorClose
        If Not itemEvents Is Nothing Then itemEvents.RemoveConnection()
    End Sub

    Private Sub adxOutlookEvents_ExplorerClose(ByVal sender As System.Object, ByVal explorer As System.Object) Handles adxOutlookEvents.ExplorerClose
        Dim count As Integer
        Dim explorers As Outlook.Explorers = Nothing
        Try
            explorers = CType(Me.HostApplication, Microsoft.Office.Interop.Outlook.Application).Explorers
            count = explorers.Count
        Catch
        Finally
            If Not explorers Is Nothing Then Marshal.ReleaseComObject(explorers)
        End Try

        canConnect = (count > 0)
    End Sub

    Private Sub adxOutlookEvents_ItemSend(ByVal sender As System.Object, ByVal e As AddinExpress.MSO.ADXOlItemSendEventArgs) Handles adxOutlookEvents.ItemSend
        If Not itemEvents Is Nothing Then itemEvents.Dispose()
    End Sub
End Class

